package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRTechnicalTitle;
import cn.ibizlab.humanresource.core.humanresource.filter.HRTechnicalTitleSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRTechnicalTitle] 服务对象接口
 */
public interface IHRTechnicalTitleService extends IService<HRTechnicalTitle>{

    boolean create(HRTechnicalTitle et) ;
    void createBatch(List<HRTechnicalTitle> list) ;
    boolean update(HRTechnicalTitle et) ;
    void updateBatch(List<HRTechnicalTitle> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRTechnicalTitle get(String key) ;
    HRTechnicalTitle getDraft(HRTechnicalTitle et) ;
    boolean checkKey(HRTechnicalTitle et) ;
    boolean save(HRTechnicalTitle et) ;
    void saveBatch(List<HRTechnicalTitle> list) ;
    Page<HRTechnicalTitle> searchDefault(HRTechnicalTitleSearchContext context) ;
    Page<HRTechnicalTitle> searchHigh(HRTechnicalTitleSearchContext context) ;
    Page<HRTechnicalTitle> searchJunior(HRTechnicalTitleSearchContext context) ;
    Page<HRTechnicalTitle> searchMiddle(HRTechnicalTitleSearchContext context) ;
    Page<HRTechnicalTitle> searchSenior(HRTechnicalTitleSearchContext context) ;
    List<HRTechnicalTitle> selectByHremployeeid(String employeeid) ;
    void removeByHremployeeid(String employeeid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRTechnicalTitle> getHrtechnicaltitleByIds(List<String> ids) ;
    List<HRTechnicalTitle> getHrtechnicaltitleByEntities(List<HRTechnicalTitle> entities) ;
}


